// Copyright (c) 2018 IIT Madras. See IITM_LICENSE.txt file for more details

//
// Generated by Bluespec Compiler, version 2018.10.beta1 (build e1df8052c, 2018-10-17)
//
// On Sat May 25 14:28:32 IST 2019
//
//
// Ports:
// Name                         I/O  size props
// inst_request_get               O    66
// RDY_inst_request_get           O     1 const
// RDY_inst_response_put          O     1 reg
// tx_stage1_operands_enq_ena     O     1
// tx_stage1_operands_enq_data    O   128
// tx_stage1_meta_enq_ena         O     1
// tx_stage1_meta_enq_data        O    65
// tx_stage1_control_enq_ena      O     1
// tx_stage1_control_enq_data     O    66 reg
// tx_stage1_dump_enq_ena         O     1
// tx_stage1_dump_enq_data        O    96
// RDY_commit_rd_put              O     1
// RDY_ma_update_eEpoch           O     1 const
// RDY_ma_update_wEpoch           O     1 const
// CLK                            I     1 clock
// RST_N                          I     1 reset
// inst_response_put              I    35 reg
// tx_stage1_operands_notFull_b   I     1 unused
// tx_stage1_operands_enq_rdy_b   I     1
// tx_stage1_meta_notFull_b       I     1 unused
// tx_stage1_meta_enq_rdy_b       I     1
// tx_stage1_control_notFull_b    I     1 unused
// tx_stage1_control_enq_rdy_b    I     1
// tx_stage1_dump_notFull_b       I     1 unused
// tx_stage1_dump_enq_rdy_b       I     1
// commit_rd_put                  I    69
// ma_flush_newpc                 I    64
// ma_csr_misa_c_c                I     1
// ma_interrupt_i                 I     1
// ma_csr_decode_c                I   155
// ma_trigger_data1_t             I    52 unused
// ma_trigger_data2_t             I   128 unused
// ma_trigger_enable_t            I     2 unused
// EN_inst_response_put           I     1
// EN_commit_rd_put               I     1
// EN_ma_flush                    I     1
// EN_ma_update_eEpoch            I     1
// EN_ma_update_wEpoch            I     1
// EN_inst_request_get            I     1
//
// Combinational paths from inputs to outputs:
//   (tx_stage1_operands_enq_rdy_b,
//    tx_stage1_meta_enq_rdy_b,
//    tx_stage1_control_enq_rdy_b,
//    tx_stage1_dump_enq_rdy_b,
//    ma_csr_misa_c_c,
//    ma_csr_decode_c,
//    EN_ma_flush) -> tx_stage1_operands_enq_ena
//   (tx_stage1_operands_enq_rdy_b,
//    tx_stage1_meta_enq_rdy_b,
//    tx_stage1_control_enq_rdy_b,
//    tx_stage1_dump_enq_rdy_b,
//    commit_rd_put,
//    ma_csr_misa_c_c,
//    ma_csr_decode_c,
//    EN_commit_rd_put,
//    EN_ma_flush) -> tx_stage1_operands_enq_data
//   (tx_stage1_operands_enq_rdy_b,
//    tx_stage1_meta_enq_rdy_b,
//    tx_stage1_control_enq_rdy_b,
//    tx_stage1_dump_enq_rdy_b,
//    ma_csr_misa_c_c,
//    ma_csr_decode_c,
//    EN_ma_flush) -> tx_stage1_meta_enq_ena
//   (tx_stage1_operands_enq_rdy_b,
//    tx_stage1_meta_enq_rdy_b,
//    tx_stage1_control_enq_rdy_b,
//    tx_stage1_dump_enq_rdy_b,
//    ma_csr_misa_c_c,
//    ma_csr_decode_c,
//    EN_ma_flush) -> tx_stage1_meta_enq_data
//   (tx_stage1_operands_enq_rdy_b,
//    tx_stage1_meta_enq_rdy_b,
//    tx_stage1_control_enq_rdy_b,
//    tx_stage1_dump_enq_rdy_b,
//    ma_csr_misa_c_c,
//    ma_csr_decode_c,
//    EN_ma_flush) -> tx_stage1_control_enq_ena
//   (tx_stage1_operands_enq_rdy_b,
//    tx_stage1_meta_enq_rdy_b,
//    tx_stage1_control_enq_rdy_b,
//    tx_stage1_dump_enq_rdy_b,
//    ma_csr_misa_c_c,
//    ma_csr_decode_c,
//    EN_ma_flush) -> tx_stage1_control_enq_data
//   (tx_stage1_operands_enq_rdy_b,
//    tx_stage1_meta_enq_rdy_b,
//    tx_stage1_control_enq_rdy_b,
//    tx_stage1_dump_enq_rdy_b,
//    ma_csr_misa_c_c,
//    ma_csr_decode_c,
//    EN_ma_flush) -> tx_stage1_dump_enq_ena
//   (tx_stage1_operands_enq_rdy_b,
//    tx_stage1_meta_enq_rdy_b,
//    tx_stage1_control_enq_rdy_b,
//    tx_stage1_dump_enq_rdy_b,
//    ma_csr_misa_c_c,
//    ma_csr_decode_c,
//    EN_ma_flush) -> tx_stage1_dump_enq_data
//
//
//  This Module implements the instruction-fetch + decode + operand-fetch functionality of  the pipeline.   1. Instruction-Fetch phase:  It generates the new PC, sends the PC to the fabric and in     return expects the instruction response from the fabric. The PC is updated    either when a flush is received from any of the later stages or is simple incremented by 4 or 2    (in case of compressed instructions)  2. Decode phase: Once the instruction is received, it is checked if the instruction is a    compressed instruction or not. If so, then it passes through a decompressor which then converts    the compressed instruction into its 32-bit equivalent encoding. The 32-bit instructions are    then    decoded to capture various informations. Most of the decoded information which holds    control-flow information is passed on to the next stage for execution.  3. Operand Fetch: The operand addresses are generated by the decoder and then used to access the    register file. The registerfile itself forward the data of the commit happening in the same    cycle.    The fetched operands are then passed on to the next stage.  4. The debugger also is given access to the registerfile through this module.  5. Triggers are also supported to capture events related to program counter or instruction match
//
// Comments on the inlined module `v_trigger_enable':
//   vector: Array of wires capturing which triggers are enabled currently
//
// Comments on the inlined module `v_trigger_data2':
//   vector: Array of wires capturing the tdata2 values from csr
//
// Comments on the inlined module `v_trigger_data1':
//   vector: Array of wires capturing the tdata1 values from csr
//
// Comments on the inlined module `integer_rf':
//   mod: operand register file
//
// Comments on the inlined module `wr_interrupt':
//   wire: This wire will be set if any interrupts have been detected by the core
//
// Comments on the inlined module `wr_csr_decode':
//   wire: this wire caries the current value of certain csrs
//
// Comments on the inlined module `wr_csr_misa_c':
//   wire: this wire carries the current value of the misa_c csr field
//
//

`ifdef BSV_ASSIGNMENT_DELAY
`else
  `define BSV_ASSIGNMENT_DELAY
`endif

`ifdef BSV_POSITIVE_RESET
  `define BSV_RESET_VALUE 1'b1
  `define BSV_RESET_EDGE posedge
`else
  `define BSV_RESET_VALUE 1'b0
  `define BSV_RESET_EDGE negedge
`endif

module mkstage1(CLK,
		RST_N,

		EN_inst_request_get,
		inst_request_get,
		RDY_inst_request_get,

		inst_response_put,
		EN_inst_response_put,
		RDY_inst_response_put,

		tx_stage1_operands_notFull_b,

		tx_stage1_operands_enq_rdy_b,

		tx_stage1_operands_enq_ena,

		tx_stage1_operands_enq_data,

		tx_stage1_meta_notFull_b,

		tx_stage1_meta_enq_rdy_b,

		tx_stage1_meta_enq_ena,

		tx_stage1_meta_enq_data,

		tx_stage1_control_notFull_b,

		tx_stage1_control_enq_rdy_b,

		tx_stage1_control_enq_ena,

		tx_stage1_control_enq_data,

		tx_stage1_dump_notFull_b,

		tx_stage1_dump_enq_rdy_b,

		tx_stage1_dump_enq_ena,

		tx_stage1_dump_enq_data,

		commit_rd_put,
		EN_commit_rd_put,
		RDY_commit_rd_put,

		ma_flush_newpc,
		EN_ma_flush,

		ma_csr_misa_c_c,

		ma_interrupt_i,

		ma_csr_decode_c,

		EN_ma_update_eEpoch,
		RDY_ma_update_eEpoch,

		EN_ma_update_wEpoch,
		RDY_ma_update_wEpoch,

		ma_trigger_data1_t,

		ma_trigger_data2_t,

		ma_trigger_enable_t);
  parameter [63 : 0] resetpc = 64'b0;
  input  CLK;
  input  RST_N;

  // actionvalue method inst_request_get
  input  EN_inst_request_get;
  output [65 : 0] inst_request_get;
  output RDY_inst_request_get;

  // action method inst_response_put
  input  [34 : 0] inst_response_put;
  input  EN_inst_response_put;
  output RDY_inst_response_put;

  // action method tx_stage1_operands_notFull
  input  tx_stage1_operands_notFull_b;

  // action method tx_stage1_operands_enq_rdy
  input  tx_stage1_operands_enq_rdy_b;

  // value method tx_stage1_operands_enq_ena
  output tx_stage1_operands_enq_ena;

  // value method tx_stage1_operands_enq_data
  output [127 : 0] tx_stage1_operands_enq_data;

  // action method tx_stage1_meta_notFull
  input  tx_stage1_meta_notFull_b;

  // action method tx_stage1_meta_enq_rdy
  input  tx_stage1_meta_enq_rdy_b;

  // value method tx_stage1_meta_enq_ena
  output tx_stage1_meta_enq_ena;

  // value method tx_stage1_meta_enq_data
  output [64 : 0] tx_stage1_meta_enq_data;

  // action method tx_stage1_control_notFull
  input  tx_stage1_control_notFull_b;

  // action method tx_stage1_control_enq_rdy
  input  tx_stage1_control_enq_rdy_b;

  // value method tx_stage1_control_enq_ena
  output tx_stage1_control_enq_ena;

  // value method tx_stage1_control_enq_data
  output [65 : 0] tx_stage1_control_enq_data;

  // action method tx_stage1_dump_notFull
  input  tx_stage1_dump_notFull_b;

  // action method tx_stage1_dump_enq_rdy
  input  tx_stage1_dump_enq_rdy_b;

  // value method tx_stage1_dump_enq_ena
  output tx_stage1_dump_enq_ena;

  // value method tx_stage1_dump_enq_data
  output [95 : 0] tx_stage1_dump_enq_data;

  // action method commit_rd_put
  input  [68 : 0] commit_rd_put;
  input  EN_commit_rd_put;
  output RDY_commit_rd_put;

  // action method ma_flush
  input  [63 : 0] ma_flush_newpc;
  input  EN_ma_flush;

  // action method ma_csr_misa_c
  input  ma_csr_misa_c_c;

  // action method ma_interrupt
  input  ma_interrupt_i;

  // action method ma_csr_decode
  input  [154 : 0] ma_csr_decode_c;

  // action method ma_update_eEpoch
  input  EN_ma_update_eEpoch;
  output RDY_ma_update_eEpoch;

  // action method ma_update_wEpoch
  input  EN_ma_update_wEpoch;
  output RDY_ma_update_wEpoch;

  // action method ma_trigger_data1
  input  [51 : 0] ma_trigger_data1_t;

  // action method ma_trigger_data2
  input  [127 : 0] ma_trigger_data2_t;

  // action method ma_trigger_enable
  input  [1 : 0] ma_trigger_enable_t;

  // signals for module outputs
  wire [127 : 0] tx_stage1_operands_enq_data;
  wire [95 : 0] tx_stage1_dump_enq_data;
  wire [65 : 0] inst_request_get, tx_stage1_control_enq_data;
  wire [64 : 0] tx_stage1_meta_enq_data;
  wire RDY_commit_rd_put,
       RDY_inst_request_get,
       RDY_inst_response_put,
       RDY_ma_update_eEpoch,
       RDY_ma_update_wEpoch,
       tx_stage1_control_enq_ena,
       tx_stage1_dump_enq_ena,
       tx_stage1_meta_enq_ena,
       tx_stage1_operands_enq_ena;

  // inlined wires
  wire [154 : 0] wr_csr_decode_wget;
  wire [64 : 0] ff_stage1_meta_w_data_wget;
  wire [63 : 0] rg_fabric_request_port0__write_1,
		rg_fabric_request_port1__read,
		rg_fabric_request_port1__write_1,
		rg_fabric_request_port2__read;
  wire integer_rf_wr_write_address_whas, integer_rf_wr_write_data_whas;

  // register rg_action
  // reg: This register implements a simple state - machine which indicates how the     instruction should be extracted from the cache response.
  reg rg_action;
  wire rg_action_D_IN, rg_action_EN;

  // register rg_discard_lower
  reg rg_discard_lower;
  wire rg_discard_lower_D_IN, rg_discard_lower_EN;

  // register rg_eEpoch
  // reg: holds the current epoch values controlled by the stage2.
  reg rg_eEpoch;
  wire rg_eEpoch_D_IN, rg_eEpoch_EN;

  // register rg_fabric_request
  // reg: register to hold the address of the next request to the fabric.
  reg [63 : 0] rg_fabric_request;
  wire [63 : 0] rg_fabric_request_D_IN;
  wire rg_fabric_request_EN;

  // register rg_index
  // reg: index into the Regfile during initialization sequence.
  reg [4 : 0] rg_index;
  wire [4 : 0] rg_index_D_IN;
  wire rg_index_EN;

  // register rg_initialize
  // reg: register to indicate that the RegFile is being initialized to all zeros
  reg rg_initialize;
  wire rg_initialize_D_IN, rg_initialize_EN;

  // register rg_pc
  // reg: register to hold the PC value of the instruction to be decoded.
  reg [63 : 0] rg_pc;
  wire [63 : 0] rg_pc_D_IN;
  wire rg_pc_EN;

  // register rg_prev
  reg [81 : 0] rg_prev;
  wire [81 : 0] rg_prev_D_IN;
  wire rg_prev_EN;

  // register rg_wEpoch
  // reg: holds the current epoch values controlled by the stage3.
  reg rg_wEpoch;
  wire rg_wEpoch_D_IN, rg_wEpoch_EN;

  // register rg_wfi
  // reg: this is register it set to True when a WFI instruction is executed. It set to     False, when an interrupt has been received or there is a flush from the write - back stage.
  reg rg_wfi;
  wire rg_wfi_D_IN, rg_wfi_EN;

  // ports of submodule ff_memory_response
  wire [34 : 0] ff_memory_response_D_IN, ff_memory_response_D_OUT;
  wire ff_memory_response_CLR,
       ff_memory_response_DEQ,
       ff_memory_response_EMPTY_N,
       ff_memory_response_ENQ,
       ff_memory_response_FULL_N;

  // ports of submodule integer_rf_rf
  wire [63 : 0] integer_rf_rf_D_IN,
		integer_rf_rf_D_OUT_1,
		integer_rf_rf_D_OUT_2;
  wire [4 : 0] integer_rf_rf_ADDR_1,
	       integer_rf_rf_ADDR_2,
	       integer_rf_rf_ADDR_3,
	       integer_rf_rf_ADDR_4,
	       integer_rf_rf_ADDR_5,
	       integer_rf_rf_ADDR_IN;
  wire integer_rf_rf_WE;

  // rule scheduling signals
  wire CAN_FIRE_RL_initialize_regfile,
       CAN_FIRE_RL_process_instruction,
       CAN_FIRE_RL_wait_for_interrupt,
       CAN_FIRE_commit_rd_put,
       CAN_FIRE_inst_request_get,
       CAN_FIRE_inst_response_put,
       CAN_FIRE_ma_csr_decode,
       CAN_FIRE_ma_csr_misa_c,
       CAN_FIRE_ma_flush,
       CAN_FIRE_ma_interrupt,
       CAN_FIRE_ma_trigger_data1,
       CAN_FIRE_ma_trigger_data2,
       CAN_FIRE_ma_trigger_enable,
       CAN_FIRE_ma_update_eEpoch,
       CAN_FIRE_ma_update_wEpoch,
       CAN_FIRE_tx_stage1_control_enq_rdy,
       CAN_FIRE_tx_stage1_control_notFull,
       CAN_FIRE_tx_stage1_dump_enq_rdy,
       CAN_FIRE_tx_stage1_dump_notFull,
       CAN_FIRE_tx_stage1_meta_enq_rdy,
       CAN_FIRE_tx_stage1_meta_notFull,
       CAN_FIRE_tx_stage1_operands_enq_rdy,
       CAN_FIRE_tx_stage1_operands_notFull,
       WILL_FIRE_RL_initialize_regfile,
       WILL_FIRE_RL_process_instruction,
       WILL_FIRE_RL_wait_for_interrupt,
       WILL_FIRE_commit_rd_put,
       WILL_FIRE_inst_request_get,
       WILL_FIRE_inst_response_put,
       WILL_FIRE_ma_csr_decode,
       WILL_FIRE_ma_csr_misa_c,
       WILL_FIRE_ma_flush,
       WILL_FIRE_ma_interrupt,
       WILL_FIRE_ma_trigger_data1,
       WILL_FIRE_ma_trigger_data2,
       WILL_FIRE_ma_trigger_enable,
       WILL_FIRE_ma_update_eEpoch,
       WILL_FIRE_ma_update_wEpoch,
       WILL_FIRE_tx_stage1_control_enq_rdy,
       WILL_FIRE_tx_stage1_control_notFull,
       WILL_FIRE_tx_stage1_dump_enq_rdy,
       WILL_FIRE_tx_stage1_dump_notFull,
       WILL_FIRE_tx_stage1_meta_enq_rdy,
       WILL_FIRE_tx_stage1_meta_notFull,
       WILL_FIRE_tx_stage1_operands_enq_rdy,
       WILL_FIRE_tx_stage1_operands_notFull;

  // inputs to muxes for submodule ports
  wire [63 : 0] MUX_rg_pc_write_1__VAL_1;
  wire MUX_rg_discard_lower_write_1__SEL_1,
       MUX_rg_pc_write_1__SEL_1,
       MUX_rg_wfi_write_1__SEL_1;

  // declarations used by system tasks
  `ifdef VERBOSE
  reg TASK_testplusargs___d269;
  reg TASK_testplusargs___d270;
  reg TASK_testplusargs___d271;
  reg [63 : 0] v__h6611;
  reg TASK_testplusargs___d2;
  reg TASK_testplusargs___d3;
  reg TASK_testplusargs___d4;
  reg [63 : 0] v__h2949;
  reg TASK_testplusargs___d17;
  reg TASK_testplusargs___d18;
  reg TASK_testplusargs___d19;
  reg [63 : 0] v__h3278;
  reg TASK_testplusargs___d79;
  reg TASK_testplusargs___d80;
  reg TASK_testplusargs___d81;
  reg [63 : 0] v__h3474;
  reg TASK_testplusargs___d97;
  reg TASK_testplusargs___d98;
  reg TASK_testplusargs___d99;
  reg [63 : 0] v__h4314;
  reg TASK_testplusargs___d105;
  reg TASK_testplusargs___d106;
  reg TASK_testplusargs___d107;
  reg [63 : 0] v__h4487;
  reg TASK_testplusargs___d204;
  reg TASK_testplusargs___d205;
  reg TASK_testplusargs___d206;
  reg [63 : 0] v__h5479;
  reg TASK_testplusargs___d211;
  reg TASK_testplusargs___d212;
  reg TASK_testplusargs___d213;
  reg [63 : 0] v__h5628;
  reg NOT_rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_mem_ETC___d84;
  reg TASK_testplusargs_7_OR_TASK_testplusargs_8_AND_ETC___d103;
  reg TASK_testplusargs_7_OR_TASK_testplusargs_8_AND_ETC___d104;
  reg NOT_IF_chk_interrupt_41_BIT_1_42_OR_ff_memory__ETC___d209;
  reg NOT_IF_chk_interrupt_41_BIT_1_42_OR_ff_memory__ETC___d216;
  `endif

  // remaining internal signals
  reg [1 : 0] CASE_IF_ff_stage1_meta_w_data_whas__26_THEN_IF_ETC__q2,
	      CASE_decoder_func_32_47_BITS_42_TO_41_0_decode_ETC__q1,
	      IF_ff_stage1_meta_w_data_whas__26_THEN_IF_ff_s_ETC___d241;
  wire [64 : 0] decoder_func_32___d147;
  wire [63 : 0] x__h5042, x__h5066, x__read__h1081, x_wget__h1070;
  wire [45 : 0] IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d191;
  wire [31 : 0] _theResult_____3__h4420,
		decode_instruction___1__h4546,
		final_instruction___1__h4540,
		final_instruction__h4097,
		y_avValue_snd_fst__h4123,
		y_avValue_snd_fst__h4131,
		y_avValue_snd_fst__h4133,
		y_avValue_snd_fst__h4155,
		y_avValue_snd_fst__h4157,
		y_avValue_snd_fst__h4188,
		y_avValue_snd_fst__h4192;
  wire [15 : 0] x1_avValue_snd_snd_instruction__h4153,
		x1_avValue_snd_snd_instruction__h4202,
		x1_avValue_snd_snd_instruction__h4205,
		x1_avValue_snd_snd_snd_instruction__h4183,
		x1_avValue_snd_snd_snd_instruction__h4208,
		x1_avValue_snd_snd_snd_instruction__h4211,
		x_instruction__h4121;
  wire [11 : 0] x__h4849;
  wire [7 : 0] chk_interrupt___d141;
  wire [6 : 0] _theResult___fst__h4866,
	       func_cause___1__h4859,
	       x1_avValue_meta_funct__h4721;
  wire [4 : 0] x__read__h1010, x_wget__h999;
  wire [3 : 0] IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d149;
  wire [1 : 0] IF_wr_csr_decode_wget__30_BITS_154_TO_153_31_E_ETC___d133,
	       curr_epoch__h2859;
  wire IF_NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_ETC___d113,
       NOT_IF_chk_interrupt_41_BIT_1_42_OR_ff_memory__ETC___d199,
       NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_3__ETC___d154,
       NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_3__ETC___d74,
       decode_word32___d189,
       ff_memory_response_i_notEmpty__3_AND_wr_csr_de_ETC___d35,
       rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53,
       rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d78,
       rg_prev_9_BITS_1_TO_0_3_EQ_rg_eEpoch_4_CONCAT__ETC___d47;

  // actionvalue method inst_request_get
  assign inst_request_get = { rg_fabric_request, curr_epoch__h2859 } ;
  assign RDY_inst_request_get = 1'd1 ;
  assign CAN_FIRE_inst_request_get = 1'd1 ;
  assign WILL_FIRE_inst_request_get = EN_inst_request_get ;

  // action method inst_response_put
  assign RDY_inst_response_put = ff_memory_response_FULL_N ;
  assign CAN_FIRE_inst_response_put = ff_memory_response_FULL_N ;
  assign WILL_FIRE_inst_response_put = EN_inst_response_put ;

  // action method tx_stage1_operands_notFull
  assign CAN_FIRE_tx_stage1_operands_notFull = 1'd1 ;
  assign WILL_FIRE_tx_stage1_operands_notFull = 1'd1 ;

  // action method tx_stage1_operands_enq_rdy
  assign CAN_FIRE_tx_stage1_operands_enq_rdy = 1'd1 ;
  assign WILL_FIRE_tx_stage1_operands_enq_rdy = 1'd1 ;

  // value method tx_stage1_operands_enq_ena
  assign tx_stage1_operands_enq_ena = MUX_rg_pc_write_1__SEL_1 ;

  // value method tx_stage1_operands_enq_data
  assign tx_stage1_operands_enq_data = { x__h5042, x__h5066 } ;

  // action method tx_stage1_meta_notFull
  assign CAN_FIRE_tx_stage1_meta_notFull = 1'd1 ;
  assign WILL_FIRE_tx_stage1_meta_notFull = 1'd1 ;

  // action method tx_stage1_meta_enq_rdy
  assign CAN_FIRE_tx_stage1_meta_enq_rdy = 1'd1 ;
  assign WILL_FIRE_tx_stage1_meta_enq_rdy = 1'd1 ;

  // value method tx_stage1_meta_enq_ena
  assign tx_stage1_meta_enq_ena = MUX_rg_pc_write_1__SEL_1 ;

  // value method tx_stage1_meta_enq_data
  assign tx_stage1_meta_enq_data =
	     { ff_stage1_meta_w_data_wget[64:43],
	       CASE_IF_ff_stage1_meta_w_data_whas__26_THEN_IF_ETC__q2,
	       ff_stage1_meta_w_data_wget[40:0] } ;

  // action method tx_stage1_control_notFull
  assign CAN_FIRE_tx_stage1_control_notFull = 1'd1 ;
  assign WILL_FIRE_tx_stage1_control_notFull = 1'd1 ;

  // action method tx_stage1_control_enq_rdy
  assign CAN_FIRE_tx_stage1_control_enq_rdy = 1'd1 ;
  assign WILL_FIRE_tx_stage1_control_enq_rdy = 1'd1 ;

  // value method tx_stage1_control_enq_ena
  assign tx_stage1_control_enq_ena = MUX_rg_pc_write_1__SEL_1 ;

  // value method tx_stage1_control_enq_data
  assign tx_stage1_control_enq_data = { curr_epoch__h2859, rg_pc } ;

  // action method tx_stage1_dump_notFull
  assign CAN_FIRE_tx_stage1_dump_notFull = 1'd1 ;
  assign WILL_FIRE_tx_stage1_dump_notFull = 1'd1 ;

  // action method tx_stage1_dump_enq_rdy
  assign CAN_FIRE_tx_stage1_dump_enq_rdy = 1'd1 ;
  assign WILL_FIRE_tx_stage1_dump_enq_rdy = 1'd1 ;

  // value method tx_stage1_dump_enq_ena
  assign tx_stage1_dump_enq_ena = MUX_rg_pc_write_1__SEL_1 ;

  // value method tx_stage1_dump_enq_data
  assign tx_stage1_dump_enq_data = { rg_pc, final_instruction__h4097 } ;

  // action method commit_rd_put
  assign RDY_commit_rd_put = !rg_initialize ;
  assign CAN_FIRE_commit_rd_put = !rg_initialize ;
  assign WILL_FIRE_commit_rd_put = EN_commit_rd_put ;

  // action method ma_flush
  assign CAN_FIRE_ma_flush = 1'd1 ;
  assign WILL_FIRE_ma_flush = EN_ma_flush ;

  // action method ma_csr_misa_c
  assign CAN_FIRE_ma_csr_misa_c = 1'd1 ;
  assign WILL_FIRE_ma_csr_misa_c = 1'd1 ;

  // action method ma_interrupt
  assign CAN_FIRE_ma_interrupt = 1'd1 ;
  assign WILL_FIRE_ma_interrupt = 1'd1 ;

  // action method ma_csr_decode
  assign CAN_FIRE_ma_csr_decode = 1'd1 ;
  assign WILL_FIRE_ma_csr_decode = 1'd1 ;

  // action method ma_update_eEpoch
  assign RDY_ma_update_eEpoch = 1'd1 ;
  assign CAN_FIRE_ma_update_eEpoch = 1'd1 ;
  assign WILL_FIRE_ma_update_eEpoch = EN_ma_update_eEpoch ;

  // action method ma_update_wEpoch
  assign RDY_ma_update_wEpoch = 1'd1 ;
  assign CAN_FIRE_ma_update_wEpoch = 1'd1 ;
  assign WILL_FIRE_ma_update_wEpoch = EN_ma_update_wEpoch ;

  // action method ma_trigger_data1
  assign CAN_FIRE_ma_trigger_data1 = 1'd1 ;
  assign WILL_FIRE_ma_trigger_data1 = 1'd1 ;

  // action method ma_trigger_data2
  assign CAN_FIRE_ma_trigger_data2 = 1'd1 ;
  assign WILL_FIRE_ma_trigger_data2 = 1'd1 ;

  // action method ma_trigger_enable
  assign CAN_FIRE_ma_trigger_enable = 1'd1 ;
  assign WILL_FIRE_ma_trigger_enable = 1'd1 ;

  // submodule ff_memory_response
  // fifo: to hold the instruction response from the fabric
  FIFO2 #(.width(32'd35), .guarded(32'd1)) ff_memory_response(.RST(RST_N),
							      .CLK(CLK),
							      .D_IN(ff_memory_response_D_IN),
							      .ENQ(ff_memory_response_ENQ),
							      .DEQ(ff_memory_response_DEQ),
							      .CLR(ff_memory_response_CLR),
							      .D_OUT(ff_memory_response_D_OUT),
							      .FULL_N(ff_memory_response_FULL_N),
							      .EMPTY_N(ff_memory_response_EMPTY_N));

  // submodule integer_rf_rf
  RegFile #(.addr_width(32'd5),
	    .data_width(32'd64),
	    .lo(5'd0),
	    .hi(5'd31)) integer_rf_rf(.CLK(CLK),
				      .ADDR_1(integer_rf_rf_ADDR_1),
				      .ADDR_2(integer_rf_rf_ADDR_2),
				      .ADDR_3(integer_rf_rf_ADDR_3),
				      .ADDR_4(integer_rf_rf_ADDR_4),
				      .ADDR_5(integer_rf_rf_ADDR_5),
				      .ADDR_IN(integer_rf_rf_ADDR_IN),
				      .D_IN(integer_rf_rf_D_IN),
				      .WE(integer_rf_rf_WE),
				      .D_OUT_1(integer_rf_rf_D_OUT_1),
				      .D_OUT_2(integer_rf_rf_D_OUT_2),
				      .D_OUT_3(),
				      .D_OUT_4(),
				      .D_OUT_5());

  // rule RL_initialize_regfile
  //   rule: initialize all the registers to 0 on reset
  assign CAN_FIRE_RL_initialize_regfile = rg_initialize ;
  assign WILL_FIRE_RL_initialize_regfile = rg_initialize ;

  // rule RL_wait_for_interrupt
  //   rule:This rule is fired when the core has executed the WFI instruction and waiting     for an intterupt to the core to resume fetch
  assign CAN_FIRE_RL_wait_for_interrupt = rg_wfi && !rg_initialize ;
  assign WILL_FIRE_RL_wait_for_interrupt =
	     CAN_FIRE_RL_wait_for_interrupt && !EN_ma_flush ;

  // rule RL_process_instruction
  //   rule:This rule will receive the instruction from the memory subsystem and decide if     the instruction is compressed or not. The final instruction is then sent to the next stage.    To extract the instruction from the memory response a state machine is implemented.        1. First the epochs are compared and if a mis - match is observed then the response is     dropped without any other changes to the state of the module.    2. if rg_discard is set and compressed is enabled then the lower 16 - bits of the    resposne are discarded and the upper 16 - bits are probed to check if it is a compressed    instruction. If so, then the instruction is sent to the next stage. However is it is not a    compressed instruction it means the upper 16 - bits of the response refer to the lower 16 -    bits of a 32 - bit instruction and thus we will have to wait for the next response from the     cache to form the instruction is send to the next stage. To ensure the concatenation happens     in the next response we set rg_action to ChecPrev and set enque_instruction to False.    3. if rg_action is set to None, then we simply probe the lower 2 - bits to the response to    check if it is compressed. If so then the lower 16 bits form an instruction which is sent to    the next stage, the upper 16 - bits are stored to rg_instruction and rg_action is set to    CheckPrev to ensure that in the next resposne we first probe rg_instruction.    4. if rg_Action if set to CheckPrev then we first probe the lower 2 - bits of the     rg_instruction which leads to two possibilities. Either rg_instruction could hold a    compressed instruction from the previous response, in which case the current memory response    is not dequed and rg_instruction is sent to the next stage. This can happen due to state - 3    mentioned above. The other possibility is that rg_instruction holds the lower 16 - bits of a    32 - bit isntruction, in which case we have concatenate the lower 16 - bits of the response     with rg_instruction and send to the next, and also store the upper 16 - bits of the response     into rg_instruction. rg_Action in this case will remain CheckPrev so that the upper bits of     this repsonse are probed in the next cycle.
  assign CAN_FIRE_RL_process_instruction =
	     ff_memory_response_i_notEmpty__3_AND_wr_csr_de_ETC___d35 &&
	     !rg_wfi &&
	     !rg_initialize ;
  assign WILL_FIRE_RL_process_instruction =
	     CAN_FIRE_RL_process_instruction && !EN_ma_flush ;

  // inputs to muxes for submodule ports
  assign MUX_rg_discard_lower_write_1__SEL_1 =
	     WILL_FIRE_RL_process_instruction &&
	     rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d78 ;
  assign MUX_rg_pc_write_1__SEL_1 =
	     WILL_FIRE_RL_process_instruction &&
	     IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d149 !=
	     4'd7 &&
	     rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 &&
	     NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_3__ETC___d154 ;
  assign MUX_rg_wfi_write_1__SEL_1 =
	     WILL_FIRE_RL_wait_for_interrupt && ma_interrupt_i ;
  assign MUX_rg_pc_write_1__VAL_1 =
	     rg_pc +
	     ((rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 &&
	       IF_NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_ETC___d113 &&
	       NOT_IF_chk_interrupt_41_BIT_1_42_OR_ff_memory__ETC___d199 &&
	       ma_csr_misa_c_c) ?
		64'd2 :
		64'd4) ;

  // inlined wires
  assign wr_csr_decode_wget =
	     { (ma_csr_decode_c[154:153] == 2'd3) ?
		 ma_csr_decode_c[154:153] :
		 2'd0,
	       ma_csr_decode_c[152:0] } ;
  assign integer_rf_wr_write_address_whas =
	     rg_initialize || EN_commit_rd_put ;
  assign integer_rf_wr_write_data_whas = EN_commit_rd_put || rg_initialize ;
  assign ff_stage1_meta_w_data_wget =
	     { decoder_func_32___d147[64:47],
	       IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d191,
	       decoder_func_32___d147[0] } ;
  assign rg_fabric_request_port0__write_1 = rg_fabric_request + 64'd4 ;
  assign rg_fabric_request_port1__read =
	     EN_inst_request_get ?
	       rg_fabric_request_port0__write_1 :
	       rg_fabric_request ;
  assign rg_fabric_request_port1__write_1 = { ma_flush_newpc[63:2], 2'b0 } ;
  assign rg_fabric_request_port2__read =
	     EN_ma_flush ?
	       rg_fabric_request_port1__write_1 :
	       rg_fabric_request_port1__read ;

  // register rg_action
  assign rg_action_D_IN =
	     !rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 ||
	     !rg_action &&
	     rg_prev_9_BITS_1_TO_0_3_EQ_rg_eEpoch_4_CONCAT__ETC___d47 ;
  assign rg_action_EN =
	     WILL_FIRE_RL_process_instruction &&
	     (NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_3__ETC___d74 ||
	      !rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53) ;

  // register rg_discard_lower
  assign rg_discard_lower_D_IN =
	     !MUX_rg_discard_lower_write_1__SEL_1 &&
	     ma_flush_newpc[1:0] != 2'd0 ;
  assign rg_discard_lower_EN =
	     WILL_FIRE_RL_process_instruction &&
	     rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d78 ||
	     EN_ma_flush ;

  // register rg_eEpoch
  assign rg_eEpoch_D_IN = ~rg_eEpoch ;
  assign rg_eEpoch_EN = EN_ma_update_eEpoch ;

  // register rg_fabric_request
  assign rg_fabric_request_D_IN = rg_fabric_request_port2__read ;
  assign rg_fabric_request_EN = 1'b1 ;

  // register rg_index
  assign rg_index_D_IN = rg_index + 5'd1 ;
  assign rg_index_EN = rg_initialize ;

  // register rg_initialize
  assign rg_initialize_D_IN = 1'd0 ;
  assign rg_initialize_EN = rg_initialize && rg_index == 5'd31 ;

  // register rg_pc
  assign rg_pc_D_IN =
	     MUX_rg_pc_write_1__SEL_1 ?
	       MUX_rg_pc_write_1__VAL_1 :
	       ma_flush_newpc ;
  assign rg_pc_EN =
	     WILL_FIRE_RL_process_instruction &&
	     IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d149 !=
	     4'd7 &&
	     rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 &&
	     NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_3__ETC___d154 ||
	     EN_ma_flush ;

  // register rg_prev
  assign rg_prev_D_IN =
	     { rg_prev[81:18], x_instruction__h4121, curr_epoch__h2859 } ;
  assign rg_prev_EN = WILL_FIRE_RL_process_instruction ;

  // register rg_wEpoch
  assign rg_wEpoch_D_IN = ~rg_wEpoch ;
  assign rg_wEpoch_EN = EN_ma_update_wEpoch ;

  // register rg_wfi
  assign rg_wfi_D_IN = !MUX_rg_wfi_write_1__SEL_1 && !EN_ma_flush ;
  assign rg_wfi_EN =
	     WILL_FIRE_RL_wait_for_interrupt && ma_interrupt_i ||
	     WILL_FIRE_RL_process_instruction &&
	     IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d149 ==
	     4'd7 &&
	     rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 &&
	     NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_3__ETC___d154 ||
	     EN_ma_flush ;

  // submodule ff_memory_response
  assign ff_memory_response_D_IN = inst_response_put ;
  assign ff_memory_response_ENQ = EN_inst_response_put ;
  assign ff_memory_response_DEQ =
	     WILL_FIRE_RL_process_instruction &&
	     (rg_prev[3:2] == 2'b11 || rg_action ||
	      !rg_prev_9_BITS_1_TO_0_3_EQ_rg_eEpoch_4_CONCAT__ETC___d47 ||
	      !rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53) ;
  assign ff_memory_response_CLR = 1'b0 ;

  // submodule integer_rf_rf
  assign integer_rf_rf_ADDR_1 = decoder_func_32___d147[59:55] ;
  assign integer_rf_rf_ADDR_2 = decoder_func_32___d147[64:60] ;
  assign integer_rf_rf_ADDR_3 = 5'h0 ;
  assign integer_rf_rf_ADDR_4 = 5'h0 ;
  assign integer_rf_rf_ADDR_5 = 5'h0 ;
  assign integer_rf_rf_ADDR_IN =
	     rg_initialize ? rg_index : commit_rd_put[68:64] ;
  assign integer_rf_rf_D_IN = rg_initialize ? 64'd0 : commit_rd_put[63:0] ;
  assign integer_rf_rf_WE = integer_rf_wr_write_address_whas ;

  // remaining internal signals
  module_fn_decompress instance_fn_decompress_2(.fn_decompress_inst(final_instruction__h4097[15:0]),
						.fn_decompress(decode_instruction___1__h4546));
  module_chk_interrupt instance_chk_interrupt_1(.chk_interrupt_prv(IF_wr_csr_decode_wget__30_BITS_154_TO_153_31_E_ETC___d133),
						.chk_interrupt_mstatus(wr_csr_decode_wget[66:3]),
						.chk_interrupt_mip({ 2'd0,
								     x__h4849 }),
						.chk_interrupt_mie(wr_csr_decode_wget[140:129]),
						.chk_interrupt_mideleg(wr_csr_decode_wget[128:117]),
						.chk_interrupt_uip(wr_csr_decode_wget[116:105]),
						.chk_interrupt_uie(wr_csr_decode_wget[104:93]),
						.chk_interrupt(chk_interrupt___d141));
  module_decoder_func_32 instance_decoder_func_32_3(.decoder_func_32_inst(_theResult_____3__h4420),
						    .decoder_func_32_csrs({ IF_wr_csr_decode_wget__30_BITS_154_TO_153_31_E_ETC___d133,
									    wr_csr_decode_wget[152:0] }),
						    .decoder_func_32_compressed(rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 &&
										IF_NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_ETC___d113),
						    .decoder_func_32(decoder_func_32___d147));
  module_decode_word32 instance_decode_word32_0(.decode_word32_inst(_theResult_____3__h4420),
						.decode_word32_misa_c(wr_csr_decode_wget[69]),
						.decode_word32(decode_word32___d189));
  assign IF_NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_ETC___d113 =
	     (!rg_action &&
	      rg_prev_9_BITS_1_TO_0_3_EQ_rg_eEpoch_4_CONCAT__ETC___d47) ?
	       rg_prev[3:2] != 2'b11 :
	       ((rg_discard_lower && ma_csr_misa_c_c) ?
		  ff_memory_response_D_OUT[20:19] != 2'b11 :
		  ff_memory_response_D_OUT[4:3] != 2'b11 && ma_csr_misa_c_c) ;
  assign IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d149 =
	     (chk_interrupt___d141[1] || ff_memory_response_D_OUT[0]) ?
	       4'd6 :
	       decoder_func_32___d147[46:43] ;
  assign IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d191 =
	     { IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d149,
	       CASE_decoder_func_32_47_BITS_42_TO_41_0_decode_ETC__q1,
	       decoder_func_32___d147[40:9],
	       x1_avValue_meta_funct__h4721,
	       decode_word32___d189 } ;
  assign IF_wr_csr_decode_wget__30_BITS_154_TO_153_31_E_ETC___d133 =
	     (wr_csr_decode_wget[154:153] == 2'd3) ?
	       wr_csr_decode_wget[154:153] :
	       2'd0 ;
  assign NOT_IF_chk_interrupt_41_BIT_1_42_OR_ff_memory__ETC___d199 =
	     IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d149 !=
	     4'd7 &&
	     (!rg_action &&
	      rg_prev_9_BITS_1_TO_0_3_EQ_rg_eEpoch_4_CONCAT__ETC___d47 ||
	      !rg_discard_lower ||
	      ff_memory_response_D_OUT[20:19] != 2'b11) ;
  assign NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_3__ETC___d154 =
	     !rg_action &&
	     rg_prev_9_BITS_1_TO_0_3_EQ_rg_eEpoch_4_CONCAT__ETC___d47 ||
	     !rg_discard_lower ||
	     !ma_csr_misa_c_c ||
	     ff_memory_response_D_OUT[20:19] != 2'b11 ;
  assign NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_3__ETC___d74 =
	     !rg_action &&
	     rg_prev_9_BITS_1_TO_0_3_EQ_rg_eEpoch_4_CONCAT__ETC___d47 &&
	     rg_prev[3:2] != 2'b11 ||
	     (rg_action ||
	      !rg_prev_9_BITS_1_TO_0_3_EQ_rg_eEpoch_4_CONCAT__ETC___d47) &&
	     (rg_discard_lower && ma_csr_misa_c_c &&
	      ff_memory_response_D_OUT[20:19] == 2'b11 ||
	      !rg_discard_lower && ff_memory_response_D_OUT[4:3] != 2'b11 &&
	      ma_csr_misa_c_c) ;
  assign _theResult_____3__h4420 =
	     (rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 &&
	      IF_NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_ETC___d113) ?
	       decode_instruction___1__h4546 :
	       final_instruction__h4097 ;
  assign _theResult___fst__h4866 =
	     ff_memory_response_D_OUT[0] ?
	       7'd1 :
	       decoder_func_32___d147[8:2] ;
  assign curr_epoch__h2859 = { rg_eEpoch, rg_wEpoch } ;
  assign ff_memory_response_i_notEmpty__3_AND_wr_csr_de_ETC___d35 =
	     ff_memory_response_EMPTY_N && tx_stage1_operands_enq_rdy_b &&
	     tx_stage1_meta_enq_rdy_b &&
	     tx_stage1_control_enq_rdy_b &&
	     tx_stage1_dump_enq_rdy_b ;
  assign final_instruction___1__h4540 =
	     { 16'd0, ff_memory_response_D_OUT[34:19] } ;
  assign final_instruction__h4097 =
	     rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 ?
	       y_avValue_snd_fst__h4123 :
	       32'd0 ;
  assign func_cause___1__h4859 = { 1'd0, chk_interrupt___d141[7:2] } ;
  assign rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 =
	     curr_epoch__h2859 == ff_memory_response_D_OUT[2:1] ;
  assign rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d78 =
	     rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 &&
	     (rg_action ||
	      !rg_prev_9_BITS_1_TO_0_3_EQ_rg_eEpoch_4_CONCAT__ETC___d47) &&
	     rg_discard_lower &&
	     ma_csr_misa_c_c ;
  assign rg_prev_9_BITS_1_TO_0_3_EQ_rg_eEpoch_4_CONCAT__ETC___d47 =
	     rg_prev[1:0] == curr_epoch__h2859 ;
  assign x1_avValue_meta_funct__h4721 =
	     chk_interrupt___d141[1] ?
	       func_cause___1__h4859 :
	       _theResult___fst__h4866 ;
  assign x1_avValue_snd_snd_instruction__h4153 =
	     (rg_prev[3:2] == 2'b11) ?
	       ff_memory_response_D_OUT[34:19] :
	       rg_prev[17:2] ;
  assign x1_avValue_snd_snd_instruction__h4202 =
	     ma_csr_misa_c_c ?
	       ff_memory_response_D_OUT[34:19] :
	       rg_prev[17:2] ;
  assign x1_avValue_snd_snd_instruction__h4205 =
	     (ff_memory_response_D_OUT[4:3] == 2'b11) ?
	       rg_prev[17:2] :
	       x1_avValue_snd_snd_instruction__h4202 ;
  assign x1_avValue_snd_snd_snd_instruction__h4183 =
	     (ff_memory_response_D_OUT[20:19] == 2'b11) ?
	       ff_memory_response_D_OUT[34:19] :
	       rg_prev[17:2] ;
  assign x1_avValue_snd_snd_snd_instruction__h4208 =
	     (rg_discard_lower && ma_csr_misa_c_c) ?
	       x1_avValue_snd_snd_snd_instruction__h4183 :
	       x1_avValue_snd_snd_instruction__h4205 ;
  assign x1_avValue_snd_snd_snd_instruction__h4211 =
	     (!rg_action &&
	      rg_prev_9_BITS_1_TO_0_3_EQ_rg_eEpoch_4_CONCAT__ETC___d47) ?
	       x1_avValue_snd_snd_instruction__h4153 :
	       x1_avValue_snd_snd_snd_instruction__h4208 ;
  assign x__h4849 = wr_csr_decode_wget[152:141] ;
  assign x__h5042 =
	     (decoder_func_32___d147[64:60] == x__read__h1010) ?
	       x__read__h1081 :
	       integer_rf_rf_D_OUT_2 ;
  assign x__h5066 =
	     (decoder_func_32___d147[59:55] == x__read__h1010) ?
	       x__read__h1081 :
	       integer_rf_rf_D_OUT_1 ;
  assign x__read__h1010 =
	     integer_rf_wr_write_address_whas ? x_wget__h999 : 5'd0 ;
  assign x__read__h1081 =
	     integer_rf_wr_write_data_whas ? x_wget__h1070 : 64'd0 ;
  assign x_instruction__h4121 =
	     rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 ?
	       x1_avValue_snd_snd_snd_instruction__h4211 :
	       rg_prev[17:2] ;
  assign x_wget__h1070 = EN_commit_rd_put ? commit_rd_put[63:0] : 64'd0 ;
  assign x_wget__h999 = rg_initialize ? rg_index : commit_rd_put[68:64] ;
  assign y_avValue_snd_fst__h4123 =
	     (!rg_action &&
	      rg_prev_9_BITS_1_TO_0_3_EQ_rg_eEpoch_4_CONCAT__ETC___d47) ?
	       y_avValue_snd_fst__h4131 :
	       y_avValue_snd_fst__h4133 ;
  assign y_avValue_snd_fst__h4131 =
	     { (rg_prev[3:2] == 2'b11) ?
		 ff_memory_response_D_OUT[18:3] :
		 16'd0,
	       rg_prev[17:2] } ;
  assign y_avValue_snd_fst__h4133 =
	     (rg_discard_lower && ma_csr_misa_c_c) ?
	       y_avValue_snd_fst__h4155 :
	       y_avValue_snd_fst__h4157 ;
  assign y_avValue_snd_fst__h4155 =
	     (ff_memory_response_D_OUT[20:19] == 2'b11) ?
	       32'd0 :
	       final_instruction___1__h4540 ;
  assign y_avValue_snd_fst__h4157 =
	     (ff_memory_response_D_OUT[4:3] == 2'b11) ?
	       ff_memory_response_D_OUT[34:3] :
	       y_avValue_snd_fst__h4188 ;
  assign y_avValue_snd_fst__h4188 =
	     ma_csr_misa_c_c ? y_avValue_snd_fst__h4192 : 32'd0 ;
  assign y_avValue_snd_fst__h4192 =
	     { 16'd0, ff_memory_response_D_OUT[18:3] } ;
  always@(decoder_func_32___d147)
  begin
    case (decoder_func_32___d147[42:41])
      2'd0, 2'd1, 2'd3:
	  CASE_decoder_func_32_47_BITS_42_TO_41_0_decode_ETC__q1 =
	      decoder_func_32___d147[42:41];
      2'd2: CASE_decoder_func_32_47_BITS_42_TO_41_0_decode_ETC__q1 = 2'd2;
    endcase
  end
  always@(ff_stage1_meta_w_data_wget)
  begin
    case (ff_stage1_meta_w_data_wget[42:41])
      2'd0, 2'd1:
	  IF_ff_stage1_meta_w_data_whas__26_THEN_IF_ff_s_ETC___d241 =
	      ff_stage1_meta_w_data_wget[42:41];
      2'd2: IF_ff_stage1_meta_w_data_whas__26_THEN_IF_ff_s_ETC___d241 = 2'd3;
      2'd3: IF_ff_stage1_meta_w_data_whas__26_THEN_IF_ff_s_ETC___d241 = 2'd2;
    endcase
  end
  always@(IF_ff_stage1_meta_w_data_whas__26_THEN_IF_ff_s_ETC___d241)
  begin
    case (IF_ff_stage1_meta_w_data_whas__26_THEN_IF_ff_s_ETC___d241)
      2'd0, 2'd1:
	  CASE_IF_ff_stage1_meta_w_data_whas__26_THEN_IF_ETC__q2 =
	      IF_ff_stage1_meta_w_data_whas__26_THEN_IF_ff_s_ETC___d241;
      2'd2: CASE_IF_ff_stage1_meta_w_data_whas__26_THEN_IF_ETC__q2 = 2'd3;
      2'd3: CASE_IF_ff_stage1_meta_w_data_whas__26_THEN_IF_ETC__q2 = 2'd2;
    endcase
  end

  // handling of inlined registers

  always@(posedge CLK)
  begin
    if (RST_N == `BSV_RESET_VALUE)
      begin
        rg_action <= `BSV_ASSIGNMENT_DELAY 1'd1;
	rg_discard_lower <= `BSV_ASSIGNMENT_DELAY 1'd0;
	rg_eEpoch <= `BSV_ASSIGNMENT_DELAY 1'd0;
	rg_fabric_request <= `BSV_ASSIGNMENT_DELAY resetpc;
	rg_index <= `BSV_ASSIGNMENT_DELAY 5'd0;
	rg_initialize <= `BSV_ASSIGNMENT_DELAY 1'd1;
	rg_pc <= `BSV_ASSIGNMENT_DELAY resetpc;
	rg_prev <= `BSV_ASSIGNMENT_DELAY 82'd0;
	rg_wEpoch <= `BSV_ASSIGNMENT_DELAY 1'd0;
	rg_wfi <= `BSV_ASSIGNMENT_DELAY 1'd0;
      end
    else
      begin
        if (rg_action_EN) rg_action <= `BSV_ASSIGNMENT_DELAY rg_action_D_IN;
	if (rg_discard_lower_EN)
	  rg_discard_lower <= `BSV_ASSIGNMENT_DELAY rg_discard_lower_D_IN;
	if (rg_eEpoch_EN) rg_eEpoch <= `BSV_ASSIGNMENT_DELAY rg_eEpoch_D_IN;
	if (rg_fabric_request_EN)
	  rg_fabric_request <= `BSV_ASSIGNMENT_DELAY rg_fabric_request_D_IN;
	if (rg_index_EN) rg_index <= `BSV_ASSIGNMENT_DELAY rg_index_D_IN;
	if (rg_initialize_EN)
	  rg_initialize <= `BSV_ASSIGNMENT_DELAY rg_initialize_D_IN;
	if (rg_pc_EN) rg_pc <= `BSV_ASSIGNMENT_DELAY rg_pc_D_IN;
	if (rg_prev_EN) rg_prev <= `BSV_ASSIGNMENT_DELAY rg_prev_D_IN;
	if (rg_wEpoch_EN) rg_wEpoch <= `BSV_ASSIGNMENT_DELAY rg_wEpoch_D_IN;
	if (rg_wfi_EN) rg_wfi <= `BSV_ASSIGNMENT_DELAY rg_wfi_D_IN;
      end
  end

  `ifdef VERBOSE
  `ifdef BSV_NO_INITIAL_BLOCKS
  `else // not BSV_NO_INITIAL_BLOCKS
  initial
  begin
    rg_action = 1'h0;
    rg_discard_lower = 1'h0;
    rg_eEpoch = 1'h0;
    rg_fabric_request = 64'hAAAAAAAAAAAAAAAA;
    rg_index = 5'h0A;
    rg_initialize = 1'h0;
    rg_pc = 64'hAAAAAAAAAAAAAAAA;
    rg_prev = 82'h2AAAAAAAAAAAAAAAAAAAA;
    rg_wEpoch = 1'h0;
    rg_wfi = 1'h0;
  end
  `endif // BSV_NO_INITIAL_BLOCKS
  `endif

  // handling of system tasks

  `ifdef VERBOSE
  always@(negedge CLK)
  begin
    #0;
    if (RST_N != `BSV_RESET_VALUE)
      if (EN_ma_flush)
	begin
	  TASK_testplusargs___d269 = $test$plusargs("fullverbose");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (EN_ma_flush)
	begin
	  TASK_testplusargs___d270 = $test$plusargs("mstage1");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (EN_ma_flush)
	begin
	  TASK_testplusargs___d271 = $test$plusargs("l0");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (EN_ma_flush)
	begin
	  v__h6611 = $time;
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (EN_ma_flush &&
	  (TASK_testplusargs___d269 ||
	   TASK_testplusargs___d270 && TASK_testplusargs___d271))
	$write("[%10d", v__h6611, "] ");
    if (RST_N != `BSV_RESET_VALUE)
      if (EN_ma_flush &&
	  (TASK_testplusargs___d269 ||
	   TASK_testplusargs___d270 && TASK_testplusargs___d271))
	$write("STAGE1 : Received Flush. PC: %h ", ma_flush_newpc);
    if (RST_N != `BSV_RESET_VALUE)
      if (EN_ma_flush &&
	  (TASK_testplusargs___d269 ||
	   TASK_testplusargs___d270 && TASK_testplusargs___d271))
	$write("\n");
    if (RST_N != `BSV_RESET_VALUE)
      if (rg_initialize)
	begin
	  TASK_testplusargs___d2 = $test$plusargs("fullverbose");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (rg_initialize)
	begin
	  TASK_testplusargs___d3 = $test$plusargs("mstage1");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (rg_initialize)
	begin
	  TASK_testplusargs___d4 = $test$plusargs("l1");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (rg_initialize)
	begin
	  v__h2949 = $time;
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (rg_initialize &&
	  (TASK_testplusargs___d2 ||
	   TASK_testplusargs___d3 && TASK_testplusargs___d4))
	$write("[%10d", v__h2949, "] ");
    if (RST_N != `BSV_RESET_VALUE)
      if (rg_initialize &&
	  (TASK_testplusargs___d2 ||
	   TASK_testplusargs___d3 && TASK_testplusargs___d4))
	$write("STAGE1: Initializing the RF. Index: %d", rg_index);
    if (RST_N != `BSV_RESET_VALUE)
      if (rg_initialize &&
	  (TASK_testplusargs___d2 ||
	   TASK_testplusargs___d3 && TASK_testplusargs___d4))
	$write("\n");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_wait_for_interrupt)
	begin
	  TASK_testplusargs___d17 = $test$plusargs("fullverbose");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_wait_for_interrupt)
	begin
	  TASK_testplusargs___d18 = $test$plusargs("mstage1");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_wait_for_interrupt)
	begin
	  TASK_testplusargs___d19 = $test$plusargs("l0");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_wait_for_interrupt)
	begin
	  v__h3278 = $time;
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_wait_for_interrupt &&
	  (TASK_testplusargs___d17 ||
	   TASK_testplusargs___d18 && TASK_testplusargs___d19))
	$write("[%10d", v__h3278, "] ");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_wait_for_interrupt &&
	  (TASK_testplusargs___d17 ||
	   TASK_testplusargs___d18 && TASK_testplusargs___d19))
	$write("STAGE1 : Waiting for Interrupt. wr_interrupt: %b",
	       ma_interrupt_i);
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_wait_for_interrupt &&
	  (TASK_testplusargs___d17 ||
	   TASK_testplusargs___d18 && TASK_testplusargs___d19))
	$write("\n");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  !rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53)
	begin
	  TASK_testplusargs___d79 = $test$plusargs("fullverbose");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  !rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53)
	begin
	  TASK_testplusargs___d80 = $test$plusargs("mstage1");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  !rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53)
	begin
	  TASK_testplusargs___d81 = $test$plusargs("l1");
	  #0;
	end
    NOT_rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_mem_ETC___d84 =
	!rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 &&
	(TASK_testplusargs___d79 ||
	 TASK_testplusargs___d80 && TASK_testplusargs___d81);
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  !rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53)
	begin
	  v__h3474 = $time;
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  NOT_rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_mem_ETC___d84)
	$write("[%10d", v__h3474, "] ");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  NOT_rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_mem_ETC___d84)
	$write("STAGE1 : Dropping Instruction from Cache");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  NOT_rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_mem_ETC___d84)
	$write("\n");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction)
	begin
	  TASK_testplusargs___d97 = $test$plusargs("fullverbose");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction)
	begin
	  TASK_testplusargs___d98 = $test$plusargs("mstage1");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction)
	begin
	  TASK_testplusargs___d99 = $test$plusargs("l1");
	  #0;
	end
    TASK_testplusargs_7_OR_TASK_testplusargs_8_AND_ETC___d103 =
	(TASK_testplusargs___d97 ||
	 TASK_testplusargs___d98 && TASK_testplusargs___d99) &&
	rg_action;
    TASK_testplusargs_7_OR_TASK_testplusargs_8_AND_ETC___d104 =
	(TASK_testplusargs___d97 ||
	 TASK_testplusargs___d98 && TASK_testplusargs___d99) &&
	!rg_action;
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction)
	begin
	  v__h4314 = $time;
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  (TASK_testplusargs___d97 ||
	   TASK_testplusargs___d98 && TASK_testplusargs___d99))
	$write("[%10d", v__h4314, "] ");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  (TASK_testplusargs___d97 ||
	   TASK_testplusargs___d98 && TASK_testplusargs___d99))
	$write("STAGE1 : rg_action: ");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  TASK_testplusargs_7_OR_TASK_testplusargs_8_AND_ETC___d103)
	$write("None");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  TASK_testplusargs_7_OR_TASK_testplusargs_8_AND_ETC___d104)
	$write("CheckPrev");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  (TASK_testplusargs___d97 ||
	   TASK_testplusargs___d98 && TASK_testplusargs___d99))
	$write(" Prev: ");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  (TASK_testplusargs___d97 ||
	   TASK_testplusargs___d98 && TASK_testplusargs___d99))
	$write("PrevMeta { ", "pc: ");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  (TASK_testplusargs___d97 ||
	   TASK_testplusargs___d98 && TASK_testplusargs___d99))
	$write("'h%h", rg_prev[81:18]);
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  (TASK_testplusargs___d97 ||
	   TASK_testplusargs___d98 && TASK_testplusargs___d99))
	$write(", ", "instruction: ");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  (TASK_testplusargs___d97 ||
	   TASK_testplusargs___d98 && TASK_testplusargs___d99))
	$write("'h%h", rg_prev[17:2]);
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  (TASK_testplusargs___d97 ||
	   TASK_testplusargs___d98 && TASK_testplusargs___d99))
	$write(", ", "epoch: ");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  (TASK_testplusargs___d97 ||
	   TASK_testplusargs___d98 && TASK_testplusargs___d99))
	$write("'h%h", rg_prev[1:0], " }");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  (TASK_testplusargs___d97 ||
	   TASK_testplusargs___d98 && TASK_testplusargs___d99))
	$write(" rg_discard:%b", rg_discard_lower);
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  (TASK_testplusargs___d97 ||
	   TASK_testplusargs___d98 && TASK_testplusargs___d99))
	$write("\n");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction)
	begin
	  TASK_testplusargs___d105 = $test$plusargs("fullverbose");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction)
	begin
	  TASK_testplusargs___d106 = $test$plusargs("mstage1");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction)
	begin
	  TASK_testplusargs___d107 = $test$plusargs("l0");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction)
	begin
	  v__h4487 = $time;
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  (TASK_testplusargs___d105 ||
	   TASK_testplusargs___d106 && TASK_testplusargs___d107))
	$write("[%10d", v__h4487, "] ");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  (TASK_testplusargs___d105 ||
	   TASK_testplusargs___d106 && TASK_testplusargs___d107))
	$write("STAGE1: Decompressed: %h", _theResult_____3__h4420);
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  (TASK_testplusargs___d105 ||
	   TASK_testplusargs___d106 && TASK_testplusargs___d107))
	$write("\n");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d149 != 4'd7 &&
	  rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 &&
	  NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_3__ETC___d154)
	begin
	  TASK_testplusargs___d204 = $test$plusargs("fullverbose");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d149 != 4'd7 &&
	  rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 &&
	  NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_3__ETC___d154)
	begin
	  TASK_testplusargs___d205 = $test$plusargs("mstage1");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d149 != 4'd7 &&
	  rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 &&
	  NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_3__ETC___d154)
	begin
	  TASK_testplusargs___d206 = $test$plusargs("l0");
	  #0;
	end
    NOT_IF_chk_interrupt_41_BIT_1_42_OR_ff_memory__ETC___d209 =
	IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d149 != 4'd7 &&
	rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 &&
	NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_3__ETC___d154 &&
	(TASK_testplusargs___d204 ||
	 TASK_testplusargs___d205 && TASK_testplusargs___d206);
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d149 != 4'd7 &&
	  rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 &&
	  NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_3__ETC___d154)
	begin
	  v__h5479 = $time;
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  NOT_IF_chk_interrupt_41_BIT_1_42_OR_ff_memory__ETC___d209)
	$write("[%10d", v__h5479, "] ");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  NOT_IF_chk_interrupt_41_BIT_1_42_OR_ff_memory__ETC___d209)
	$write("STAGE1 : ");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  NOT_IF_chk_interrupt_41_BIT_1_42_OR_ff_memory__ETC___d209)
	$write("TraceDump { ", "pc: ");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  NOT_IF_chk_interrupt_41_BIT_1_42_OR_ff_memory__ETC___d209)
	$write("'h%h", rg_pc);
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  NOT_IF_chk_interrupt_41_BIT_1_42_OR_ff_memory__ETC___d209)
	$write(", ", "instruction: ");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  NOT_IF_chk_interrupt_41_BIT_1_42_OR_ff_memory__ETC___d209)
	$write("'h%h", final_instruction__h4097, " }");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  NOT_IF_chk_interrupt_41_BIT_1_42_OR_ff_memory__ETC___d209)
	$write("\n");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d149 != 4'd7 &&
	  rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 &&
	  NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_3__ETC___d154)
	begin
	  TASK_testplusargs___d211 = $test$plusargs("fullverbose");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d149 != 4'd7 &&
	  rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 &&
	  NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_3__ETC___d154)
	begin
	  TASK_testplusargs___d212 = $test$plusargs("mstage1");
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d149 != 4'd7 &&
	  rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 &&
	  NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_3__ETC___d154)
	begin
	  TASK_testplusargs___d213 = $test$plusargs("l1");
	  #0;
	end
    NOT_IF_chk_interrupt_41_BIT_1_42_OR_ff_memory__ETC___d216 =
	IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d149 != 4'd7 &&
	rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 &&
	NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_3__ETC___d154 &&
	(TASK_testplusargs___d211 ||
	 TASK_testplusargs___d212 && TASK_testplusargs___d213);
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  IF_chk_interrupt_41_BIT_1_42_OR_ff_memory_resp_ETC___d149 != 4'd7 &&
	  rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 &&
	  NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_3__ETC___d154)
	begin
	  v__h5628 = $time;
	  #0;
	end
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  NOT_IF_chk_interrupt_41_BIT_1_42_OR_ff_memory__ETC___d216)
	$write("[%10d", v__h5628, "] ");
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  NOT_IF_chk_interrupt_41_BIT_1_42_OR_ff_memory__ETC___d216)
	$write("STAGE1 : compressed: %b perform_decode: %b curr_epoch: %b",
	       rg_eEpoch_4_CONCAT_rg_wEpoch_5_6_EQ_ff_memory__ETC___d53 &&
	       IF_NOT_rg_action_2_6_AND_rg_prev_9_BITS_1_TO_0_ETC___d113,
	       1'd1,
	       curr_epoch__h2859);
    if (RST_N != `BSV_RESET_VALUE)
      if (WILL_FIRE_RL_process_instruction &&
	  NOT_IF_chk_interrupt_41_BIT_1_42_OR_ff_memory__ETC___d216)
	$write("\n");
  end
  `endif
endmodule  // mkstage1

